/*
POS API

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package posapi

import (
	"encoding/json"
)

// checks if the GetReceiptWebhook type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GetReceiptWebhook{}

// GetReceiptWebhook struct for GetReceiptWebhook
type GetReceiptWebhook struct {
	TransactionId string `json:"transaction_id"`
	ChannelId string `json:"channel_id"`
	ConversationId string `json:"conversation_id"`
	ContactId string `json:"contact_id"`
	Attributes map[string]interface{} `json:"attributes,omitempty"`
	Receipt GetReceiptWebhookReceipt `json:"receipt"`
}

// NewGetReceiptWebhook instantiates a new GetReceiptWebhook object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGetReceiptWebhook(transactionId string, channelId string, conversationId string, contactId string, receipt GetReceiptWebhookReceipt) *GetReceiptWebhook {
	this := GetReceiptWebhook{}
	this.TransactionId = transactionId
	this.ChannelId = channelId
	this.ConversationId = conversationId
	this.ContactId = contactId
	this.Receipt = receipt
	return &this
}

// NewGetReceiptWebhookWithDefaults instantiates a new GetReceiptWebhook object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGetReceiptWebhookWithDefaults() *GetReceiptWebhook {
	this := GetReceiptWebhook{}
	return &this
}

// GetTransactionId returns the TransactionId field value
func (o *GetReceiptWebhook) GetTransactionId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.TransactionId
}

// GetTransactionIdOk returns a tuple with the TransactionId field value
// and a boolean to check if the value has been set.
func (o *GetReceiptWebhook) GetTransactionIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.TransactionId, true
}

// SetTransactionId sets field value
func (o *GetReceiptWebhook) SetTransactionId(v string) {
	o.TransactionId = v
}

// GetChannelId returns the ChannelId field value
func (o *GetReceiptWebhook) GetChannelId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ChannelId
}

// GetChannelIdOk returns a tuple with the ChannelId field value
// and a boolean to check if the value has been set.
func (o *GetReceiptWebhook) GetChannelIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ChannelId, true
}

// SetChannelId sets field value
func (o *GetReceiptWebhook) SetChannelId(v string) {
	o.ChannelId = v
}

// GetConversationId returns the ConversationId field value
func (o *GetReceiptWebhook) GetConversationId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ConversationId
}

// GetConversationIdOk returns a tuple with the ConversationId field value
// and a boolean to check if the value has been set.
func (o *GetReceiptWebhook) GetConversationIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ConversationId, true
}

// SetConversationId sets field value
func (o *GetReceiptWebhook) SetConversationId(v string) {
	o.ConversationId = v
}

// GetContactId returns the ContactId field value
func (o *GetReceiptWebhook) GetContactId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ContactId
}

// GetContactIdOk returns a tuple with the ContactId field value
// and a boolean to check if the value has been set.
func (o *GetReceiptWebhook) GetContactIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ContactId, true
}

// SetContactId sets field value
func (o *GetReceiptWebhook) SetContactId(v string) {
	o.ContactId = v
}

// GetAttributes returns the Attributes field value if set, zero value otherwise.
func (o *GetReceiptWebhook) GetAttributes() map[string]interface{} {
	if o == nil || IsNil(o.Attributes) {
		var ret map[string]interface{}
		return ret
	}
	return o.Attributes
}

// GetAttributesOk returns a tuple with the Attributes field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GetReceiptWebhook) GetAttributesOk() (map[string]interface{}, bool) {
	if o == nil || IsNil(o.Attributes) {
		return map[string]interface{}{}, false
	}
	return o.Attributes, true
}

// HasAttributes returns a boolean if a field has been set.
func (o *GetReceiptWebhook) HasAttributes() bool {
	if o != nil && !IsNil(o.Attributes) {
		return true
	}

	return false
}

// SetAttributes gets a reference to the given map[string]interface{} and assigns it to the Attributes field.
func (o *GetReceiptWebhook) SetAttributes(v map[string]interface{}) {
	o.Attributes = v
}

// GetReceipt returns the Receipt field value
func (o *GetReceiptWebhook) GetReceipt() GetReceiptWebhookReceipt {
	if o == nil {
		var ret GetReceiptWebhookReceipt
		return ret
	}

	return o.Receipt
}

// GetReceiptOk returns a tuple with the Receipt field value
// and a boolean to check if the value has been set.
func (o *GetReceiptWebhook) GetReceiptOk() (*GetReceiptWebhookReceipt, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Receipt, true
}

// SetReceipt sets field value
func (o *GetReceiptWebhook) SetReceipt(v GetReceiptWebhookReceipt) {
	o.Receipt = v
}

func (o GetReceiptWebhook) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GetReceiptWebhook) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["transaction_id"] = o.TransactionId
	toSerialize["channel_id"] = o.ChannelId
	toSerialize["conversation_id"] = o.ConversationId
	toSerialize["contact_id"] = o.ContactId
	if !IsNil(o.Attributes) {
		toSerialize["attributes"] = o.Attributes
	}
	toSerialize["receipt"] = o.Receipt
	return toSerialize, nil
}

type NullableGetReceiptWebhook struct {
	value *GetReceiptWebhook
	isSet bool
}

func (v NullableGetReceiptWebhook) Get() *GetReceiptWebhook {
	return v.value
}

func (v *NullableGetReceiptWebhook) Set(val *GetReceiptWebhook) {
	v.value = val
	v.isSet = true
}

func (v NullableGetReceiptWebhook) IsSet() bool {
	return v.isSet
}

func (v *NullableGetReceiptWebhook) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGetReceiptWebhook(val *GetReceiptWebhook) *NullableGetReceiptWebhook {
	return &NullableGetReceiptWebhook{value: val, isSet: true}
}

func (v NullableGetReceiptWebhook) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGetReceiptWebhook) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


